﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using System.Diagnostics;
using System.Reflection;
using Infragistics.Win.UltraWinEditors;
using System.Collections;

namespace MemDataTable_CS
{
    public partial class Form1 : Form
    {
        private DataTable dt1;

        public Form1()
        {
            //System.Threading.Thread.CurrentThread.CurrentCulture = new System.Globalization.CultureInfo("ja-JP");
            //System.Threading.Thread.CurrentThread.CurrentUICulture = new System.Globalization.CultureInfo("ja-JP");

            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Set grid's DataSource
            dt1 = DummyDataCreator.GetData(20, new Type[] { typeof(string), typeof(int) });
            dt1.TableName = "Band 0";

            foreach (DataRow row in this.dt1.Rows)
            {
            }

            dt1.AcceptChanges();
            this.ultraGrid1.DataSource = dt1;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var band = layout.Bands[0];
            var ov = layout.Override;

            ov.HeaderClickAction = HeaderClickAction.SortMulti;
            band.Columns["String 1"].SortComparer = new MySortComparer();
        }
    }

    internal class MySortComparer : IComparer
    {
        int IComparer.Compare(object x, object y)
        {
            // x and y will be UltraGridCell. So cast them to the correct type. 
            var xCell = (UltraGridCell)x;
            var yCell = (UltraGridCell)y;

            // Get the rows
            var xRow = xCell.Row;
            var yRow = yCell.Row;

            // Get the value of the "Int32 1" cell in each row. 
            // If there is a chance that the value will be null or 
            // DBNull, you will need to check for that here. 
            int xInt = (int)xRow.Cells["Int32 1"].Value;
            int yInt = (int)yRow.Cells["Int32 1"].Value;

            // Return the comparison of the two integer values. 
            return xInt.CompareTo(yInt);
        }
    }
}
